//Version  January 7, 2007 Final
//+------------------------------------------------------------------+
//|                                                 JJMASeries().mqh |
//|                       JMA code: Copyright  1998, Jurik Research |
//|                                          http://www.jurikres.com | 
//|              MQL4 JJMASeries: Copyright  2006, Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+ 
  /*
  +SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS <<<  JJMASeries() >>> SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+

  +-----------------------------------------+ <<<  >>> +----------------------------------------------------+

    JJMASeries()          JMA      
  ,                .     ,  
  nJMA.limit  ,  !  ,    JJMASeries(),    
  .       MetaTrader\experts\include\  ,   nJMA.bar , 
  nJMA.MaxBar,    JJMASeries()    !   ! , ,  
            -        !    JJMASeries()
          ,    .  
    JJMASeries()         ,     
             !       
    JJMASeries(),                nJMA....   dJMA.... 
  JJMASeries()                  ,    
    ,             JJMASeries() 
          nJMA.number.    JJMASeries()        
    ,          ,       
       JJMASeries()      (nJMA.number). 
  
  +-------------------------------------+ <<<   >>> +-------------------------------------------------+

  nJMA.number -      JJMASeries(). (0, 1, 2, 3 ......)
  nJMA.dinJ   - ,    nJMA.Length  nJMA.Phase   . 0 -    
                ,    - .
  nJMA.MaxBar -   ,            (bar).       
                Bars-1-period;     "period" -   ,         dJMA.series   
                ;
  nJMA.limit  -            ,      
                   Bars-IndicatorCounted()-1;
  nJMA.Length -  
  nJMA.Phase  - ,    -100 ... +100,     ;
  dJMA.series -   ,      JJMASeries();
  nJMA.bar    -   ,              
                .          nJMA.limit!!!

  +------------------------------------+ <<<   >>> +-------------------------------------------------+

  JJMASeries()-   dJMA.JMA.       nJMA.bar      nJMA.MaxBar-30  JJMASeries() 
                  !!!
  nJMA.reset  - ,     ,   0 ,       ,
                0,    .      ,   !!!!
                 
  +-----------------------------------+ <<<   >>> +-----------------------------------------------+
  
      JJMASeries(),       0, (     
            )          
     ,                JJMASeries()     
  JJMASeriesResize()       :   JJMASeriesResize(nJMA.number+1);        
  nJMA.number(MaxJMA.number)          JJMASeries(),         , 
   nJMA.number. 
  
  +--------------------------------------+ <<<   >>> +-------------------------------------------------+
  
           ,       
  .       JJMASeries()       \MetaTrader\EXPERTS\LOGS\. ,   
    JJMASeries()   ,   ,  MQL4 ,       
      .     JJMASeries()   JJMASeries()  MQL4 ,
                   .      
    JJMASeries()  nJMA.number         nJJMAResize.Size   
         .        
      nJMA.limit.          init()    
          JJMASeries(),      JJMASeriesResize      
          .      JJMASeries()  
            nJMA.bar,        
  .  ,            
    ,      JJMASeries()         ,      
    .       JJMASeries()       
        .        
     ,       init(). 
  
  +---------------------------------+ <<<     >>> +--------------------------------------------+

//----+   JJMASeries()
#include <JJMASeries.mqh>
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//----    
SetIndexStyle (0,DRAW_LINE); 
//---- 1     
SetIndexBuffer(0,Ind_Buffer);
//----+      JJMASeries, nJMA.number=1(    JJMASeries)
if(JJMASeriesResize(1)==0)return(-1);
return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator function                                        |
//+------------------------------------------------------------------+
int start()
{
//----+        
int reset,bar,MaxBar,limit,counted_bars=IndicatorCounted(); 
//----    
if (counted_bars<0)return(-1);
//----       (    JJMASeries()     !!!)
if (counted_bars>0) counted_bars--;
//----     ,        
int limit=Bars-counted_bars-1;
MaxBar=Bars-1;
//----+ 
for(bar=limit;bar>=0;bar--)
 (
  double Series=Close[bar];
  //----+    JJMASeries()   0    Ind_Buffer[], 
  // nJMA.Phase  nJMA.Length      (nJMA.din=0)
  double Resalt=JJMASeries(0,0,MaxBar,limit,Phase,Length,Series,bar,reset);
  if (reset!=0)return(-1);
  Ind_Buffer[bar]=Resalt;
 }
return(0);
}
//----+ 

  */
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//+++++++++++++++++++++++++++++++++++++++++++++++++++++ <<< JJMASeries()>>> ++++++++++++++++++++++++++++++++++++++++++++++++++++++++++|
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+

//----++ <<<   >>> +SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
double dJMAf18[1],dJMAf38[1],dJMAfA8[1],dJMAfC0[1],dJMAfC8[1],dJMAs8[1],dJMAs18[1],dJMAv1[1],dJMAv2[1];
double dJMAv3[1],dJMAf90[1],dJMAf78[1],dJMAf88[1],dJMAf98[1],dJMAJMA[1],dJMAlist[1][128],dJMAring1[1][128];
double dJMAring2[1][11],dJMAbuffer[1][62],dJMAmem1[1][8],dJMAmem3[1][128],dJMARING1[1][128],dJMARING2[1][11];
double dJMALIST[1][128],dJMAKg[1],dJMAPf[1];
//--+
int    nJMAs28[1],nJMAs30[1],nJMAs38[1],nJMAs40[1],nJMAs48[1],nJMAf0[1],nJMAs50[1],nJMAs70[1],nJMALP2[1];   
int    nJMALP1[1],nJMAmem2[1][7],nJMAmem7[1][11];
int    nJMATIME[1];
//--+ +-------------------------------------------------------------------------------------------------------------+
double dJMAfA0,dJMAvv,dJMAv4,dJMAf70,dJMAs20,dJMAs10,dJMAfB0,dJMAfD0,dJMAf8,dJMAf60,dJMAf20,dJMAf28;
double dJMAf30,dJMAf40,dJMAf48,dJMAf58,dJMAf68;
//--+
int    nJMAv5,nJMAv6,nJMAfE0,nJMAfD8,nJMAfE8,nJMAval,nJMAs58,nJMAs60,nJMAs68,nJMAaa,nJMAsize;
int    nJMAii,nJMAjj,nJMAm,nJMAn,nJMATnew,nJMATold,nJMAError,nJMAResize;

//----++ <<<   JJMASeries() >>> +SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+

double JJMASeries
(
int nJMAnumber, int nJMAdin,       int nJMAMaxBar, int nJMAlimit,
int nJMAPhase,  int nJMALength, double dJMAseries, int nJMAbar,   int& nJMAreset
)
//----++ +SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
{
int nJMAn=nJMAnumber;

nJMAreset=1;
//=====+ <<<    >>> ====================================================================================================+
if (nJMAbar==nJMAlimit)
 {
  //----++     JJMASeries()
  if(nJMAResize<1)
   {
    Print("JJMASeries number ="+nJMAn+
         ".         JJMASeriesResize()");
    if(nJMAResize==0)
        Print("JJMASeries number ="+nJMAn+
                ".      JJMASeriesResize()   ");
    return(0.0);
   }
  //----++       ,   JJMASeries()
  nJMAError=GetLastError();
  if(nJMAError>4000)
   {
    Print("JJMASeries number ="+nJMAn+
         ".  ,     JJMASeries() number = "+nJMAn+" !!!");
    Print("JJMASeries number ="+nJMAn+ ". ",JMA_ErrDescr(nJMAError));  
   } 
                                                   
  //----++       nJMA.number  nJMAResize.Number
  nJMAsize=ArraySize(dJMAJMA);
  if (nJMAsize< nJMAn) 
   {
    Print("JJMASeries number ="+nJMAn+
          ". !!!     nJMA.number="
                                                        +nJMAn+"  JJMASeries()");
    Print("JJMASeries number ="+nJMAn+
          ".       nJJMAResize.Size="
                                               +nJMAsize+"  JJMASeriesResize()");
    return(0.0);
   }
 }
//----++        nJMA.bar
if((nJMAlimit>=nJMAMaxBar)&&(nJMAbar==0))
    if((nJMAMaxBar>30)&&(nJMATIME[nJMAn]==0))
                  Print("JJMASeries number ="+nJMAn+
                        ". !!!      nJMA.bar   !!!");  
//----++ +==============================================================================================================================+ 
if (nJMAbar> nJMAMaxBar){nJMAreset=0;return(0.0);}
if((nJMAbar==nJMAMaxBar)||(nJMAdin!=0)) 
  {
   //----++ <<<    >>> +SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
   double nJMADr,nJMADs,nJMADl;
   if(nJMALength < 1.0000000002) nJMADr = 0.0000000001;
   else nJMADr= (nJMALength - 1.0) / 2.0;
   if((nJMAPhase >= -100)&&(nJMAPhase <= 100))dJMAPf[nJMAn] = nJMAPhase / 100.0 + 1.5;
   if (nJMAPhase > 100) dJMAPf[nJMAn] = 2.5;
   if (nJMAPhase < -100) dJMAPf[nJMAn] = 0.5;
   nJMADr = nJMADr * 0.9; dJMAKg[nJMAn] = nJMADr/(nJMADr + 2.0);
   nJMADs=MathSqrt(nJMADr);nJMADl=MathLog(nJMADs); dJMAv1[nJMAn]= nJMADl;dJMAv2[nJMAn] = dJMAv1[nJMAn];
   if((dJMAv1[nJMAn] / MathLog(2.0)) + 2.0 < 0.0) dJMAv3[nJMAn]= 0.0;
   else dJMAv3[nJMAn]=(dJMAv2[nJMAn]/MathLog(2.0))+ 2.0;
   dJMAf98[nJMAn]= dJMAv3[nJMAn];
   if( dJMAf98[nJMAn] >= 2.5 ) dJMAf88[nJMAn] = dJMAf98[nJMAn] - 2.0;
   else dJMAf88[nJMAn]= 0.5;
   dJMAf78[nJMAn]= nJMADs * dJMAf98[nJMAn]; dJMAf90[nJMAn]= dJMAf78[nJMAn] / (dJMAf78[nJMAn] + 1.0);
   //----++SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
  }
//--+
if((nJMAbar==nJMAlimit)&&(nJMAlimit<nJMAMaxBar))
  {
   //----+ <<<    >>> +SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
   nJMATnew=Time[nJMAlimit+1];
   nJMATold=nJMATIME[nJMAn];
   //--+
   if(nJMATnew==nJMATold)
     {
      for(nJMAaa=127;nJMAaa>=0;nJMAaa--)dJMAlist [nJMAn][nJMAaa]=dJMALIST [nJMAn][nJMAaa];
      for(nJMAaa=127;nJMAaa>=0;nJMAaa--)dJMAring1[nJMAn][nJMAaa]=dJMARING1[nJMAn][nJMAaa];
      for(nJMAaa=10; nJMAaa>=0;nJMAaa--)dJMAring2[nJMAn][nJMAaa]=dJMARING2[nJMAn][nJMAaa];
      //--+
      dJMAfC0[nJMAn]=dJMAmem1[nJMAn][00];dJMAfC8[nJMAn]=dJMAmem1[nJMAn][01];dJMAfA8[nJMAn]=dJMAmem1[nJMAn][02];
      dJMAs8 [nJMAn]=dJMAmem1[nJMAn][03];dJMAf18[nJMAn]=dJMAmem1[nJMAn][04];dJMAf38[nJMAn]=dJMAmem1[nJMAn][05];
      dJMAs18[nJMAn]=dJMAmem1[nJMAn][06];dJMAJMA[nJMAn]=dJMAmem1[nJMAn][07];nJMAs38[nJMAn]=nJMAmem2[nJMAn][00];
      nJMAs48[nJMAn]=nJMAmem2[nJMAn][01];nJMAs50[nJMAn]=nJMAmem2[nJMAn][02];nJMALP1[nJMAn]=nJMAmem2[nJMAn][03];
      nJMALP2[nJMAn]=nJMAmem2[nJMAn][04];nJMAs40[nJMAn]=nJMAmem2[nJMAn][05];nJMAs70[nJMAn]=nJMAmem2[nJMAn][06];
     } 
   //--+   
   if(nJMATnew!=nJMATold)
    {
     nJMAreset=-1;
     //--+       nJMA.limit  JJMASeries()
     if (nJMATnew>nJMATold)
       {
        Print("JJMASeries number ="+nJMAn+
                 ". !!!  nJMA.limit  JJMASeries() ,  ");
       }
     else 
       { 
        int nJMALimitERROR=nJMAlimit+1-iBarShift(NULL,0,nJMATold,TRUE);
        Print("JMASerries number ="+nJMAn+
                ". !!!  nJMA.limit  JJMASeries() ,    "
                                                                                        +nJMALimitERROR+"");
       }
     //--+   nJMA.reset=-1;     JJMASeries
     return(0);
    }
  //----+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
  } 
if (nJMAbar==1)    
if (( nJMAlimit!=1)||(Time[nJMAlimit+2]==nJMATIME[nJMAn]))
  {
   //--+ <<<    >>> +SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
   for(nJMAaa=127;nJMAaa>=0;nJMAaa--)dJMALIST [nJMAn][nJMAaa]=dJMAlist [nJMAn][nJMAaa];
   for(nJMAaa=127;nJMAaa>=0;nJMAaa--)dJMARING1[nJMAn][nJMAaa]=dJMAring1[nJMAn][nJMAaa];
   for(nJMAaa=10; nJMAaa>=0;nJMAaa--)dJMARING2[nJMAn][nJMAaa]=dJMAring2[nJMAn][nJMAaa];
   //--+
   dJMAmem1[nJMAn][00]=dJMAfC0[nJMAn];dJMAmem1[nJMAn][01]=dJMAfC8[nJMAn];dJMAmem1[nJMAn][02]=dJMAfA8[nJMAn];
   dJMAmem1[nJMAn][03]=dJMAs8 [nJMAn];dJMAmem1[nJMAn][04]=dJMAf18[nJMAn];dJMAmem1[nJMAn][05]=dJMAf38[nJMAn];
   dJMAmem1[nJMAn][06]=dJMAs18[nJMAn];dJMAmem1[nJMAn][07]=dJMAJMA[nJMAn];nJMAmem2[nJMAn][00]=nJMAs38[nJMAn];
   nJMAmem2[nJMAn][01]=nJMAs48[nJMAn];nJMAmem2[nJMAn][02]=nJMAs50[nJMAn];nJMAmem2[nJMAn][03]=nJMALP1[nJMAn];
   nJMAmem2[nJMAn][04]=nJMALP2[nJMAn];nJMAmem2[nJMAn][05]=nJMAs40[nJMAn];nJMAmem2[nJMAn][06]=nJMAs70[nJMAn];
   nJMATIME[nJMAn]=Time[2];
   //--+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
  } 
//----+
if (nJMALP1[nJMAn]<61){nJMALP1[nJMAn]++; dJMAbuffer[nJMAn][nJMALP1[nJMAn]]=dJMAseries;}
if (nJMALP1[nJMAn]>30)
{
//++++++++++++++++++
if (nJMAf0[nJMAn] != 0)
{
nJMAf0[nJMAn] = 0; 
nJMAv5 = 1;
nJMAfD8 = nJMAv5*30;
if (nJMAfD8 == 0) dJMAf38[nJMAn] = dJMAseries; else dJMAf38[nJMAn] = dJMAbuffer[nJMAn][1];
dJMAf18[nJMAn] = dJMAf38[nJMAn];
if (nJMAfD8 > 29) nJMAfD8 = 29;
}
else nJMAfD8 = 0;
for(nJMAii=nJMAfD8; nJMAii>=0; nJMAii--)
{
nJMAval=31-nJMAii;
if (nJMAii == 0) dJMAf8 = dJMAseries; else dJMAf8 = dJMAbuffer[nJMAn][nJMAval];
dJMAf28 = dJMAf8 - dJMAf18[nJMAn]; dJMAf48 = dJMAf8 - dJMAf38[nJMAn];
if (MathAbs(dJMAf28) > MathAbs(dJMAf48)) dJMAv2[nJMAn] = MathAbs(dJMAf28); else dJMAv2[nJMAn] = MathAbs(dJMAf48);
dJMAfA0 = dJMAv2[nJMAn]; dJMAvv = dJMAfA0 + 0.0000000001; //{1.0e-10;}
if (nJMAs48[nJMAn] <= 1) nJMAs48[nJMAn] = 127; else nJMAs48[nJMAn] = nJMAs48[nJMAn] - 1;
if (nJMAs50[nJMAn] <= 1) nJMAs50[nJMAn] = 10;  else nJMAs50[nJMAn] = nJMAs50[nJMAn] - 1;
if (nJMAs70[nJMAn] < 128) nJMAs70[nJMAn] = nJMAs70[nJMAn] + 1;
dJMAs8[nJMAn] = dJMAs8[nJMAn] + dJMAvv - dJMAring2[nJMAn][nJMAs50[nJMAn]];
dJMAring2[nJMAn][nJMAs50[nJMAn]] = dJMAvv;
if (nJMAs70[nJMAn] > 10) dJMAs20 = dJMAs8[nJMAn] / 10.0; else dJMAs20 = dJMAs8[nJMAn] / nJMAs70[nJMAn];
if (nJMAs70[nJMAn] > 127)
{
dJMAs10 = dJMAring1[nJMAn][nJMAs48[nJMAn]];
dJMAring1[nJMAn][nJMAs48[nJMAn]] = dJMAs20; nJMAs68 = 64; nJMAs58 = nJMAs68;
while (nJMAs68 > 1)
{
if (dJMAlist[nJMAn][nJMAs58] < dJMAs10){nJMAs68 = nJMAs68 *0.5; nJMAs58 = nJMAs58 + nJMAs68;}
else 
if (dJMAlist[nJMAn][nJMAs58]<= dJMAs10) nJMAs68 = 1; else{nJMAs68 = nJMAs68 *0.5; nJMAs58 = nJMAs58 - nJMAs68;}
}
}
else
{
dJMAring1[nJMAn][nJMAs48[nJMAn]] = dJMAs20;
if  (nJMAs28[nJMAn] + nJMAs30[nJMAn] > 127){nJMAs30[nJMAn] = nJMAs30[nJMAn] - 1; nJMAs58 = nJMAs30[nJMAn];}
else{nJMAs28[nJMAn] = nJMAs28[nJMAn] + 1; nJMAs58 = nJMAs28[nJMAn];}
if  (nJMAs28[nJMAn] > 96) nJMAs38[nJMAn] = 96; else nJMAs38[nJMAn] = nJMAs28[nJMAn];
if  (nJMAs30[nJMAn] < 32) nJMAs40[nJMAn] = 32; else nJMAs40[nJMAn] = nJMAs30[nJMAn];
}
nJMAs68 = 64; nJMAs60 = nJMAs68;
while (nJMAs68 > 1)
{
if (dJMAlist[nJMAn][nJMAs60] >= dJMAs20)
{
if (dJMAlist[nJMAn][nJMAs60 - 1] <= dJMAs20) nJMAs68 = 1; else {nJMAs68 = nJMAs68 *0.5; nJMAs60 = nJMAs60 - nJMAs68; }
}
else{nJMAs68 = nJMAs68 *0.5; nJMAs60 = nJMAs60 + nJMAs68;}
if ((nJMAs60 == 127) && (dJMAs20 > dJMAlist[nJMAn][127])) nJMAs60 = 128;
}
if (nJMAs70[nJMAn] > 127)
{
if (nJMAs58 >= nJMAs60)
{
if ((nJMAs38[nJMAn] + 1 > nJMAs60) && (nJMAs40[nJMAn] - 1 < nJMAs60)) dJMAs18[nJMAn] = dJMAs18[nJMAn] + dJMAs20;
else 
if ((nJMAs40[nJMAn] + 0 > nJMAs60) && (nJMAs40[nJMAn] - 1 < nJMAs58)) dJMAs18[nJMAn] 
= dJMAs18[nJMAn] + dJMAlist[nJMAn][nJMAs40[nJMAn] - 1];
}
else
if (nJMAs40[nJMAn] >= nJMAs60) {if ((nJMAs38[nJMAn] + 1 < nJMAs60) && (nJMAs38[nJMAn] + 1 > nJMAs58)) dJMAs18[nJMAn] 
= dJMAs18[nJMAn] + dJMAlist[nJMAn][nJMAs38[nJMAn] + 1]; }
else if  (nJMAs38[nJMAn] + 2 > nJMAs60) dJMAs18[nJMAn] = dJMAs18[nJMAn] + dJMAs20; 
else if ((nJMAs38[nJMAn] + 1 < nJMAs60) && (nJMAs38[nJMAn] + 1 > nJMAs58)) dJMAs18[nJMAn] 
= dJMAs18[nJMAn] + dJMAlist[nJMAn][nJMAs38[nJMAn] + 1];
if (nJMAs58 > nJMAs60)
{
if ((nJMAs40[nJMAn] - 1 < nJMAs58) && (nJMAs38[nJMAn] + 1 > nJMAs58)) dJMAs18[nJMAn] = dJMAs18[nJMAn] - dJMAlist[nJMAn][nJMAs58];
else 
if ((nJMAs38[nJMAn]     < nJMAs58) && (nJMAs38[nJMAn] + 1 > nJMAs60)) dJMAs18[nJMAn] = dJMAs18[nJMAn] - dJMAlist[nJMAn][nJMAs38[nJMAn]];
}
else
{
if ((nJMAs38[nJMAn] + 1 > nJMAs58) && (nJMAs40[nJMAn] - 1 < nJMAs58)) dJMAs18[nJMAn] = dJMAs18[nJMAn] - dJMAlist[nJMAn][nJMAs58];
else
if ((nJMAs40[nJMAn] + 0 > nJMAs58) && (nJMAs40[nJMAn] - 0 < nJMAs60)) dJMAs18[nJMAn] = dJMAs18[nJMAn] - dJMAlist[nJMAn][nJMAs40[nJMAn]];
}
}
if (nJMAs58 <= nJMAs60)
{
if (nJMAs58 >= nJMAs60)
{
dJMAlist[nJMAn][nJMAs60] = dJMAs20;
}
else
{
for( nJMAjj = nJMAs58 + 1; nJMAjj<=nJMAs60 - 1 ;nJMAjj++)dJMAlist[nJMAn][nJMAjj - 1] = dJMAlist[nJMAn][nJMAjj];
dJMAlist[nJMAn][nJMAs60 - 1] = dJMAs20;
}
}
else
{
for( nJMAjj = nJMAs58 - 1; nJMAjj>=nJMAs60 ;nJMAjj--) dJMAlist[nJMAn][nJMAjj + 1] = dJMAlist[nJMAn][nJMAjj];
dJMAlist[nJMAn][nJMAs60] = dJMAs20;
}
if (nJMAs70[nJMAn] <= 127)
{
dJMAs18[nJMAn] = 0;
for( nJMAjj = nJMAs40[nJMAn] ; nJMAjj<=nJMAs38[nJMAn] ;nJMAjj++) dJMAs18[nJMAn] = dJMAs18[nJMAn] + dJMAlist[nJMAn][nJMAjj];
}
dJMAf60 = dJMAs18[nJMAn] / (nJMAs38[nJMAn] - nJMAs40[nJMAn] + 1.0);
if (nJMALP2[nJMAn] + 1 > 31) nJMALP2[nJMAn] = 31; else nJMALP2[nJMAn] = nJMALP2[nJMAn] + 1;
if (nJMALP2[nJMAn] <= 30)
{
if (dJMAf28 > 0.0) dJMAf18[nJMAn] = dJMAf8; else dJMAf18[nJMAn] = dJMAf8 - dJMAf28 * dJMAf90[nJMAn];
if (dJMAf48 < 0.0) dJMAf38[nJMAn] = dJMAf8; else dJMAf38[nJMAn] = dJMAf8 - dJMAf48 * dJMAf90[nJMAn];
dJMAJMA[nJMAn] = dJMAseries;
if (nJMALP2[nJMAn]!=30) continue;
if (nJMALP2[nJMAn]==30)
{
dJMAfC0[nJMAn] = dJMAseries;
if ( MathCeil(dJMAf78[nJMAn]) >= 1) dJMAv4 = MathCeil(dJMAf78[nJMAn]); else dJMAv4 = 1.0;

if(dJMAv4>0)nJMAfE8 = MathFloor(dJMAv4);else{if(dJMAv4<0)nJMAfE8 = MathCeil (dJMAv4);else nJMAfE8 = 0.0;}

if (MathFloor(dJMAf78[nJMAn]) >= 1) dJMAv2[nJMAn] = MathFloor(dJMAf78[nJMAn]); else dJMAv2[nJMAn] = 1.0;

if(dJMAv2[nJMAn]>0)nJMAfE0 = MathFloor(dJMAv2[nJMAn]);else{if(dJMAv2[nJMAn]<0)nJMAfE0 = MathCeil (dJMAv2[nJMAn]);else nJMAfE0 = 0.0;}

if (nJMAfE8== nJMAfE0) dJMAf68 = 1.0; else {dJMAv4 = nJMAfE8 - nJMAfE0; dJMAf68 = (dJMAf78[nJMAn] - nJMAfE0) / dJMAv4;}
if (nJMAfE0 <= 29) nJMAv5 = nJMAfE0; else nJMAv5 = 29;
if (nJMAfE8 <= 29) nJMAv6 = nJMAfE8; else nJMAv6 = 29;
dJMAfA8[nJMAn] = (dJMAseries - dJMAbuffer[nJMAn][nJMALP1[nJMAn] - nJMAv5]) * (1.0 - dJMAf68) / nJMAfE0 + (dJMAseries 
- dJMAbuffer[nJMAn][nJMALP1[nJMAn] - nJMAv6]) * dJMAf68 / nJMAfE8;
}
}
else
{
if (dJMAf98[nJMAn] >= MathPow(dJMAfA0/dJMAf60, dJMAf88[nJMAn])) dJMAv1[nJMAn] = MathPow(dJMAfA0/dJMAf60, dJMAf88[nJMAn]);
else dJMAv1[nJMAn] = dJMAf98[nJMAn];
if (dJMAv1[nJMAn] < 1.0) dJMAv2[nJMAn] = 1.0;
else
{if(dJMAf98[nJMAn] >= MathPow(dJMAfA0/dJMAf60, dJMAf88[nJMAn])) dJMAv3[nJMAn] = MathPow(dJMAfA0/dJMAf60, dJMAf88[nJMAn]);
else dJMAv3[nJMAn] = dJMAf98[nJMAn]; dJMAv2[nJMAn] = dJMAv3[nJMAn];}
dJMAf58 = dJMAv2[nJMAn]; dJMAf70 = MathPow(dJMAf90[nJMAn], MathSqrt(dJMAf58));
if (dJMAf28 > 0.0) dJMAf18[nJMAn] = dJMAf8; else dJMAf18[nJMAn] = dJMAf8 - dJMAf28 * dJMAf70;
if (dJMAf48 < 0.0) dJMAf38[nJMAn] = dJMAf8; else dJMAf38[nJMAn] = dJMAf8 - dJMAf48 * dJMAf70;
}
}
if (nJMALP2[nJMAn] >30)
{
dJMAf30 = MathPow(dJMAKg[nJMAn], dJMAf58);
dJMAfC0[nJMAn] =(1.0 - dJMAf30) * dJMAseries + dJMAf30 * dJMAfC0[nJMAn];
dJMAfC8[nJMAn] =(dJMAseries - dJMAfC0[nJMAn]) * (1.0 - dJMAKg[nJMAn]) + dJMAKg[nJMAn] * dJMAfC8[nJMAn];
dJMAfD0 = dJMAPf[nJMAn] * dJMAfC8[nJMAn] + dJMAfC0[nJMAn];
dJMAf20 = dJMAf30 *(-2.0);
dJMAf40 = dJMAf30 * dJMAf30;
dJMAfB0 = dJMAf20 + dJMAf40 + 1.0;
dJMAfA8[nJMAn] =(dJMAfD0 - dJMAJMA[nJMAn]) * dJMAfB0 + dJMAf40 * dJMAfA8[nJMAn];
dJMAJMA[nJMAn] = dJMAJMA[nJMAn] + dJMAfA8[nJMAn];
}
}
//++++++++++++++++++
if (nJMALP1[nJMAn] <=30)dJMAJMA[nJMAn]=0.0;
//----+ 

//----++         JJMASeries()
nJMAError=GetLastError();
if(nJMAError>4000)
  {
    Print("JJMASeries number ="+nJMAn+".    JJMASeries()  !!!");
    Print("JJMASeries number ="+nJMAn+ ". ",JMA_ErrDescr(nJMAError));   
    return(0.0);
  }

nJMAreset=0;
return(dJMAJMA[nJMAn]);
//----+     JJMASeries() --------------------------+
}

//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
// JJMASeriesResize -               | 
//  JJMASeries.  : JJMASeriesResize(5);  5 -      | 
// JJMASeries()  .      JJMASeriesResize     |
//                                        |
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
int JJMASeriesResize(int nJJMAResizeSize)
 {
//----+
  if(nJJMAResizeSize<1)
   {
    Print("JJMASeriesResize: !!!  nJJMAResize.Size     !!!"); 
    nJMAResize=-1; 
    return(0);
   }  
  int nJJMAResizereset,nJJMAResizecycle;
  //--+
  while(nJJMAResizecycle==0)
   {
    //----++ <<<     >>> +SSSSSSSSSSSSSSSSSSSSSSS+
    if(ArrayResize(dJMAlist,  nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAring1, nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAring2, nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAbuffer,nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAmem1,  nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(nJMAmem2,  nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(nJMAmem7,  nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAmem3,  nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMALIST,  nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMARING1, nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMARING2, nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAKg,    nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAPf,    nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAf18,   nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAf38,   nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAfA8,   nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAfC0,   nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAfC8,   nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAs8,    nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAs18,   nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAJMA,   nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(nJMAs50,   nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(nJMAs70,   nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(nJMALP2,   nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(nJMALP1,   nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(nJMAs38,   nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(nJMAs40,   nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(nJMAs48,   nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAv1,    nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAv2,    nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAv3,    nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAf90,   nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAf78,   nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAf88,   nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(dJMAf98,   nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(nJMAs28,   nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(nJMAs30,   nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(nJMAf0,    nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    if(ArrayResize(nJMATIME,  nJJMAResizeSize)==0){nJJMAResizereset=-1;break;}
    //+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
    nJJMAResizecycle=1;
   }
  //--+
  if(nJJMAResizereset==-1)
   {
    Print("JJMASeriesResize: !!!        JJMASeries().");   
    int nJJMAResizeError=GetLastError();
    if(nJJMAResizeError>4000)Print("JJMASeriesResize(): ",JMA_ErrDescr(nJJMAResizeError));                                                                                                                                                                                                            
    nJMAResize=-2;
    return(0);
   }
  else  
   {
    Print("JJMASeriesResize: JJMASeries()size = "+nJJMAResizeSize+"");

    //----+-------------------------------------------------------------------+
    ArrayInitialize(nJMAf0,  1);
    ArrayInitialize(nJMAs28,63);
    ArrayInitialize(nJMAs30,64);
    for(int rrr=0;rrr<nJJMAResizeSize;rrr++)
     {
       for(int kkk=0;kkk<=nJMAs28[rrr];kkk++)dJMAlist[rrr][kkk]=-1000000.0;
       for(kkk=nJMAs30[rrr]; kkk<=127; kkk++)dJMAlist[rrr][kkk]= 1000000.0;
     }
    //----+-------------------------------------------------------------------+
    nJMAResize=nJJMAResizeSize;
    return(nJJMAResizeSize);
   }  
//----+
 }
//--+ --------------------------------------------------------------------------------------------+
/*
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
JJMASeriesAlert  -                 | 
nJMA.Length  nJMA.Phase  JJMASeries.                                                          |
  --------------------------    --------------------------                            |
JJMASeriesAlert.Number                                                                                |
JJMASeriesAlert.ExternVar      nJMA.Length                       |
JJMASeriesAlert.name      nJMA.Phase,  JJMASeriesAlert.Number=0   |
 nJMA.Phase,  JJMASeriesAlert.Number=1.                                                        |
  --------------------------    -----------------------                            |
  int init()                                                                                          |
//----                                                                                                |
 -                                                         |
                                                                                                      |
//----                                         |
JJMASeriesAlert(0,"Length1",Length1);                                                                 |
JJMASeriesAlert(0,"Length2",Length2);                                                                 |
JJMASeriesAlert(1,"Phase1",Phase1);                                                                   |                                                            
JJMASeriesAlert(1,"Phase2",Phase2);                                                                   |                                                          
//----                                                                         |
return(0);                                                                                            |
}                                                                                                     |
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
*/
void JJMASeriesAlert
 (
  int JJMASeriesAlertNumber, string JJMASeriesAlertname, int JJMASeriesAlertExternVar
 )
 {
  //----        ==========================+ 
  if(JJMASeriesAlertNumber==0)if(JJMASeriesAlertExternVar<1)
          {Alert(" "+JJMASeriesAlertname+"     1" 
          + "    " +JJMASeriesAlertExternVar+ "    1"  );}
  if(JJMASeriesAlertNumber==1)
   {
    if((JJMASeriesAlertExternVar<-100)||(JJMASeriesAlertExternVar> 100))
          {Alert(" "+JJMASeriesAlertname+"    -100  +100" 
          + "    "+JJMASeriesAlertExternVar+  "   -100");}
   }
 }
//--+ --------------------------------------------------------------------------------------------+

/*
    01.12.2006  
//+------------------------------------------------------------------+
                                          JMA_ErrDescr(MQL4_RUS).mqh |
                         Copyright  2004, MetaQuotes Software Corp. |
                                          http://www.metaquotes.net/ |
  JMA_ErrDescr()   MQL4       |
      .                                |
  --------------------    ----------------------- | 
 int Error=GetLastError();                                           |
 if(Error>4000)Print(JMA_ErrDescr(Error));                           |
//+------------------------------------------------------------------+
*/
string JMA_ErrDescr(int error_code)
 {
  string error_string;
//----
  switch(error_code)
    {
     //---- MQL4  
     case 4000: error_string="  = "+error_code+".  ";                                                  break;
     case 4001: error_string="  = "+error_code+".   ";                              break;
     case 4002: error_string="  = "+error_code+".      ";                 break;
     case 4003: error_string="  = "+error_code+".     ";                                break;
     case 4004: error_string="  = "+error_code+".     ";                break;
     case 4005: error_string="  = "+error_code+".       ";                 break;
     case 4006: error_string="  = "+error_code+".     ";                         break;
     case 4007: error_string="  = "+error_code+".     ";                             break;
     case 4008: error_string="  = "+error_code+".  ";                                 break;
     case 4009: error_string="  = "+error_code+".    ";                       break;
     case 4010: error_string="  = "+error_code+".     ";                           break;
     case 4011: error_string="  = "+error_code+".   ";                                      break;
     case 4012: error_string="  = "+error_code+".     ";                                  break;
     case 4013: error_string="  = "+error_code+".   ";                                             break;
     case 4014: error_string="  = "+error_code+".  ";                                         break;
     case 4015: error_string="  = "+error_code+".   (never generated error)";                break;
     case 4016: error_string="  = "+error_code+".  ";                                 break;
     case 4017: error_string="  = "+error_code+".  DLL  ";                                     break;
     case 4018: error_string="  = "+error_code+".   ";                             break;
     case 4019: error_string="  = "+error_code+".   ";                                  break;
     case 4020: error_string="  = "+error_code+".      ";            break;
     case 4021: error_string="  = "+error_code+".    ,   ";     break;
     case 4022: error_string="  = "+error_code+".   (never generated error)";                      break;
     case 4050: error_string="  = "+error_code+".    ";                  break;
     case 4051: error_string="  = "+error_code+".    ";                     break;
     case 4052: error_string="  = "+error_code+".    ";                         break;
     case 4053: error_string="  = "+error_code+".  ";                                              break;
     case 4054: error_string="  = "+error_code+".   -";                break;
     case 4055: error_string="  = "+error_code+".   ";                         break;
     case 4056: error_string="  = "+error_code+".  ";                                        break;
     case 4057: error_string="  = "+error_code+".    ";                     break;
     case 4058: error_string="  = "+error_code+".    ";                         break;
     case 4059: error_string="  = "+error_code+".      ";                      break;
     case 4060: error_string="  = "+error_code+".   ";                                     break;
     case 4061: error_string="  = "+error_code+".   ";                                       break;
     case 4062: error_string="  = "+error_code+".    string";                              break;
     case 4063: error_string="  = "+error_code+".    integer";                             break;
     case 4064: error_string="  = "+error_code+".    double";                              break;
     case 4065: error_string="  = "+error_code+".     ";                       break;
     case 4066: error_string="  = "+error_code+".      ";      break;
     case 4067: error_string="  = "+error_code+".     ";                     break;
     case 4099: error_string="  = "+error_code+".  ";                                                 break;
     case 4100: error_string="  = "+error_code+".     ";                                  break;
     case 4101: error_string="  = "+error_code+".   ";                                      break;
     case 4102: error_string="  = "+error_code+".    ";                               break;
     case 4103: error_string="  = "+error_code+".   ";                                     break;
     case 4104: error_string="  = "+error_code+".     ";                         break;
     case 4105: error_string="  = "+error_code+".     ";                                     break;
     case 4106: error_string="  = "+error_code+".  ";                                          break;
     case 4107: error_string="  = "+error_code+".      ";             break;
     case 4108: error_string="  = "+error_code+".   ";                                       break;
     case 4109: error_string="  = "+error_code+".   ";                                       break;
     case 4110: error_string="  = "+error_code+".    ";                                break;
     case 4111: error_string="  = "+error_code+".    ";                               break;
     case 4200: error_string="  = "+error_code+".   ";                                       break;
     case 4201: error_string="  = "+error_code+".    ";                      break;
     case 4202: error_string="  = "+error_code+".   ";                                        break;
     case 4203: error_string="  = "+error_code+".   ";                                     break;
     case 4204: error_string="  = "+error_code+".   ";                                           break;
     case 4205: error_string="  = "+error_code+".   ";                                    break;
     case 4206: error_string="  = "+error_code+".    ";                                break;
     case 4207: error_string="  = "+error_code+".     ";                                break;
     default:   error_string="  = "+error_code+".  ";
    }
//----
  return(error_string);
 }
//+------------------------------------------------------------------+


