//Version  January 1, 2007
//+------------------------------------------------------------------+
//|                                                  PriceSeries.mqh |
//|                        Copyright  2006,        Nikolay Kositsin | 
//|                              Khabarovsk,   farria@mail.redcom.ru | 
//+------------------------------------------------------------------+ 
//  PriceSeries()        nPriceSeries.Bar 
//    PriceSeries.Input_Price_Customs:
//(0-CLOSE, 1-OPEN, 2-HIGH, 3-LOW, 4-MEDIAN, 5-TYPICAL, 6-WEIGHTED, 7-Heiken Ashi Close, 8-SIMPL, 9-TRENDFOLLOW, 
//10-0.5*TRENDFOLLOW, 11-Heiken Ashi High, 12-Heiken Ashi Low, 13-Heiken Ashi Open, 14-Heiken Ashi Close,
// : minuse = PriceSeries(Input_Price_Customs, bar) - PriceSeries(Input_Price_Customs, bar+1);
// ;  Momentum = PriceSeries(Input_Price_Customs, bar) - PriceSeries(Input_Price_Customs, bar+Momentum_Period); 
  
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//++++++++++++++++++++++++++++++++++++ <<< PriceSeries >>> +++++++++++++++++++++++++++++++++++++++++++++++++++++++++|
//SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+

double PriceSeries(int PriceSeriesInput_Price_Customs, int nPriceSeriesBar)
 {
  double dPriceSeries;
  switch(PriceSeriesInput_Price_Customs)
   {
    case  0: dPriceSeries = Close[nPriceSeriesBar];break;
    case  1: dPriceSeries = Open [nPriceSeriesBar];break;
    case  2: dPriceSeries = High [nPriceSeriesBar];break;
    case  3: dPriceSeries = Low  [nPriceSeriesBar];break;
    case  4: dPriceSeries =(High [nPriceSeriesBar]+Low  [nPriceSeriesBar])/2;break;
    case  5: dPriceSeries =(Close[nPriceSeriesBar]+High [nPriceSeriesBar]+Low[nPriceSeriesBar])/3;break;
    case  6: dPriceSeries =(Open [nPriceSeriesBar]+High [nPriceSeriesBar]+Low[nPriceSeriesBar]+Close[nPriceSeriesBar])/4;break;
    case  7: dPriceSeries =(Open [nPriceSeriesBar]+Close[nPriceSeriesBar])/2;break;
    case  8: dPriceSeries =(Close[nPriceSeriesBar]+High [nPriceSeriesBar]+Low[nPriceSeriesBar]+Close[nPriceSeriesBar])/4;break;
    case  9: dPriceSeries = TrendFollow00(nPriceSeriesBar);break;
    case 10: dPriceSeries = TrendFollow01(nPriceSeriesBar);break;
    case 11: dPriceSeries = iCustom(NULL,0,"Heiken Ashi#",0,nPriceSeriesBar);break;
    case 12: dPriceSeries = iCustom(NULL,0,"Heiken Ashi#",1,nPriceSeriesBar);break;
    case 13: dPriceSeries = iCustom(NULL,0,"Heiken Ashi#",2,nPriceSeriesBar);break;
    case 14: dPriceSeries = iCustom(NULL,0,"Heiken Ashi#",3,nPriceSeriesBar);break;

    default: dPriceSeries = Close[nPriceSeriesBar];
   }
  return(dPriceSeries);
 }
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+

//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//----+   TrendFollow00.  case 9 --------------------------------------------+
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
double TrendFollow00(int nTrendFollow00Bar)
 {
  double dTrendFollow00;
  double dTrendFollow00high= High [nTrendFollow00Bar];
  double dTrendFollow00low=  Low  [nTrendFollow00Bar];
  double dTrendFollow00open= Open [nTrendFollow00Bar];
  double dTrendFollow00close=Close[nTrendFollow00Bar];

  if(dTrendFollow00close>dTrendFollow00open)dTrendFollow00 = dTrendFollow00high;
  else
  {
  if(dTrendFollow00close<dTrendFollow00open)dTrendFollow00 = dTrendFollow00low;
                                                 else dTrendFollow00 = dTrendFollow00close;
  }
  return(dTrendFollow00);
 }
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//----+   TrendFollow01.  case 10 -------------------------------------------+
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
double TrendFollow01(int nTrendFollow01Bar)
 {
  double dTrendFollow01;
  double dTrendFollow01high= High [nTrendFollow01Bar];
  double dTrendFollow01low=  Low  [nTrendFollow01Bar];
  double dTrendFollow01open= Open [nTrendFollow01Bar];
  double dTrendFollow01close=Close[nTrendFollow01Bar];

  if(dTrendFollow01close>dTrendFollow01open)
                        dTrendFollow01 =(dTrendFollow01high+dTrendFollow01close)/2;
  else
   {
  if(dTrendFollow01close<dTrendFollow01open)
                        dTrendFollow01 = (dTrendFollow01low+dTrendFollow01close)/2;
                   else dTrendFollow01 = dTrendFollow01close;
   }
  return(dTrendFollow01);
 }
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
//----+   PriceSeriesAlert -----------------------------------------------------+
//  PriceSeriesAlert()           |
// PriceSeries.Input_Price_Customs    PriceSeries().                      |
//+SSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSSS+
void PriceSeriesAlert(int nPriceSeriesAlertIPC)
 {
  if(nPriceSeriesAlertIPC< 0)
      Alert(" Input_Price_Customs      0" 
               + "    "+nPriceSeriesAlertIPC+ "   0");
  if(nPriceSeriesAlertIPC>14)
      Alert(" Input_Price_Customs     14" 
               + "    "+nPriceSeriesAlertIPC+ "   0");
 }
//----+ ---------------------------------------------------------------------------------------+